
Redmine - Feature #16098

On relation change/add notification setting

2014-02-14 11:24 - Markus Nemetz

Status: New Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Email notifications Estimated time: 0.00 hour

Target version: Candidate for next major release   

Resolution:    

Description

Would it be possible to enable a following feature?

On Relation add/Change no status mail should be sent (to be set yes/no)

Reason: It leads to spam

Related issues:

Related to Redmine - Feature #5238: Related issues option accessible during i... New 2010-04-02

Related to Redmine - Feature #10792: Adding/deleting a sub-issue or some issu... New

Related to Redmine - Patch #36265: More flexible options for issue notifications New

Has duplicate Redmine - Feature #17208: Make relation change notifications co... Closed

History

#1 - 2014-04-05 04:03 - Toshi MARUYAMA

- Subject changed from On relation change/add do not send mail to On relation change/add notification setting

#2 - 2014-06-17 09:30 - Robert Pollak

Duplicated by #17208.

#3 - 2014-06-17 19:49 - Etienne Massip

- Has duplicate Feature #17208: Make relation change notifications configurable added

#4 - 2014-10-07 23:39 - Zbynek Drlik

+1

#5 - 2014-10-07 23:54 - Marcel Gavalier

+1

#6 - 2014-11-27 10:26 - @ go2null

A mitigation would be to allow adding multiple relations before submitting.

Of course, adding this to the regular issue Edit would be awesome.

(There's already a request for this - Feature #5238 Related issues option accessible during issue creation)

#7 - 2014-12-27 04:50 - Toshi MARUYAMA

- Related to Feature #5238: Related issues option accessible during issue creation added

#8 - 2015-04-14 04:11 - Go MAEDA

- Related to Feature #10792: Adding/deleting a sub-issue or some issue-relation should trigger an email added

#9 - 2015-06-04 07:59 - Kevin Palm

+1

#10 - 2015-09-09 15:15 - Marc D.

+1
#11 - 2015-12-10 10:17 - Patryk Bar

+1

#12 - 2016-11-07 20:18 - Moh Ahmed

+1

#13 - 2017-08-10 15:07 - Marc D.

+1

Maybe just add it to the Setting -> Email notifications menu

#14 - 2017-11-07 14:08 - Jonas De Meulenaere

+1

#15 - 2018-10-04 17:16 - Christophe Portier

Many users in my company complain about this

=> + at least 10

#16 - 2019-09-18 23:57 - Tomohisa Kusukawa

+1

#17 - 2019-09-19 00:24 - Yuuki NARA

+1

#18 - 2019-09-19 02:28 - Go MAEDA

- File notified_events_relation@2x.png added

I think it can be resolved if "Relation updated" checkbox is added to "Administration" > "Settings" > "Email notifications" tab. IMHO, the checkbox

should have been added when #1005 was implemented in Redmine 2.4.0.

 

#19 - 2019-09-19 12:14 - Yuuki NARA

Just change the one line below and email will not be sent when setting the relation.

This is just a workaround.

Of course, it is best to select a check box for email notification.   #note-18

I confirmed the operation with Redmine3.4.

The same goes for 4.0.

I hope it helps

models/journal.rb

def send_notification

(Setting.notified_events.include?('issue_priority_updated') && new_value_for('priority_id').present?)

)

Mailer.deliver_issue_edit(self)
 to

(Setting.notified_events.include?('issue_priority_updated') && new_value_for('priority_id').present?)

) && !(new_value_for('relates').present?)

Mailer.deliver_issue_edit(self)

#20 - 2019-09-25 09:12 - Yuichi HARADA

- File 16098_notified_events_relation.patch added

Go MAEDA wrote:

I think it can be resolved if "Relation updated" checkbox is added to "Administration" > "Settings" > "Email notifications" tab. IMHO, the checkbox

should have been added when #1005 was implemented in Redmine 2.4.0.

 Added "Relation updated" checkbox to "Administration" > "Settings" > "Email notifications" tab.

I attached a patch.

#21 - 2019-09-27 11:54 - Go MAEDA

- Target version set to Candidate for next major release

#22 - 2019-09-30 16:24 - Go MAEDA

- Target version changed from Candidate for next major release to 4.2.0

Setting the target version to 4.2.0.

#23 - 2019-10-02 03:17 - Go MAEDA

- Status changed from New to Needs feedback

- Target version changed from 4.2.0 to Candidate for next major release

Yuichi HARADA wrote:

Added "Relation updated" checkbox to "Administration" > "Settings" > "Email notifications" tab.

I attached a patch.

 A test fails on r18582. Could you check the patch?

$ bin/rails test test/unit/journal_observer_test.rb:178

Run options: --seed 52037

# Running:

F

Failure:

JournalObserverTest#test_create_relation_should_send_email_notification_with_issue_relation_updated [/Users/ma

eda/redmines/trunk/test/unit/journal_observer_test.rb:190]:

Expected: 2

  Actual: 4

bin/rails test test/unit/journal_observer_test.rb:178

Finished in 3.732650s, 0.2679 runs/s, 0.5358 assertions/s.

1 runs, 2 assertions, 1 failures, 0 errors, 0 skips

#24 - 2019-10-02 05:22 - Go MAEDA

- File email-deliveries@2x.png added

Go MAEDA wrote:

A test fails on r18582. Could you check the patch?

2025-05-17 3/5

https://www.redmine.org/issues/1005
https://www.redmine.org/projects/redmine/repository/svn/revisions/18582
https://www.redmine.org/projects/redmine/repository/svn/revisions/18582


 I think the expected value of ActionMailer::Base.deliveries.size should be 4 because notification for 2 issues (both ends of the relation) are sent to 2

users (jsmith and dlopper). jsmith is the author of both issues. dlopper receives all notification of the project (his email notifications setting is "For any

event on all my projects).

 

#25 - 2019-10-03 03:46 - Yuichi HARADA

- File 16098_notified_events_relation-v2.patch added

Go MAEDA wrote:

Go MAEDA wrote:

A test fails on r18582. Could you check the patch?

 I think the expected value of ActionMailer::Base.deliveries.size should be 4 because notification for 2 issues (both ends of the relation) are sent

to 2 users (jsmith and dlopper). jsmith is the author of both issues. dlopper receives all notification of the project (his email notifications setting is

"For any event on all my projects).

 Thank you for pointing it out. The reason for the incorrect assertion result was not enough fixtures.

I rewrote the patch.

#26 - 2019-10-04 05:00 - Go MAEDA

- Status changed from Needs feedback to New

#27 - 2019-10-06 05:34 - Mischa The Evil

Yuichi HARADA wrote:

[...]

I rewrote the patch.

 Can you split the test like you did with the patch for #17840?

#28 - 2019-10-07 02:58 - Yuichi HARADA

- File 16098_notified_events_relation-v3.patch added

Mischa The Evil wrote:

Yuichi HARADA wrote:

[...]

I rewrote the patch.

 Can you split the test like you did with the patch for #17840?

 Thank you for pointing it out. I split the test.

Attach the patch.

#29 - 2019-12-20 05:55 - Go MAEDA

- File 16098_notified_events_relation-v4.patch added

- Target version changed from Candidate for next major release to 4.1.0

Setting the target version to 4.1.0. I think it is better to deliver this feature along with #17840 in 4.1.0.

Attached is an updated patch that can be applied to the current trunk.
#30 - 2019-12-20 08:50 - Jean-Philippe Lang

- Target version changed from 4.1.0 to 4.2.0

I think that this patch doesn't solve the reported issue.

What it brings : it would let users enable notification for relations when they haven't enabled notification for all updates.

What is requested : have notifications for all updates except when relations are updated

The right solution would be to add checkboxes for all the possible causes of notification and let users choose.

#31 - 2019-12-20 08:58 - Jean-Philippe Lang

- Assignee set to Jean-Philippe Lang

#32 - 2021-03-18 20:16 - Marius BĂLTEANU

- Target version changed from 4.2.0 to 5.0.0

#33 - 2022-03-20 22:24 - Marius BĂLTEANU

- Target version changed from 5.0.0 to Candidate for next major release

#34 - 2023-05-29 09:59 - Nicolas Soria

+1

#35 - 2023-05-29 11:50 - Dmitry Makurin 

The patch #36265 implements #note-30

#36 - 2023-09-19 21:40 - Kelvin Lomberg

+1 for this OR #36265

#37 - 2024-09-16 09:02 - Jonas De Meulenaere

- Related to Patch #36265: More flexible options for issue notifications added

Files

notified_events_relation@2x.png 22 KB 2019-09-19 Go MAEDA

16098_notified_events_relation.patch 3.91 KB 2019-09-25 Yuichi HARADA

email-deliveries@2x.png 29.7 KB 2019-10-02 Go MAEDA

16098_notified_events_relation-v2.patch 3.93 KB 2019-10-03 Yuichi HARADA

16098_notified_events_relation-v3.patch 3.84 KB 2019-10-07 Yuichi HARADA

16098_notified_events_relation-v4.patch 3.85 KB 2019-12-20 Go MAEDA
